import {
  DeleteResponse,
  GetDataResponse,
  GetRelationshipsDataResponse,
  GetRelationshipsResponse,
} from '../requests';

export const getIncluded = (
  payload: any,
  relationships: GetRelationshipsResponse[],
  state: any,
  attributes: any
) => {
  if (payload.included) {
    payload.included.forEach((include: GetDataResponse<any>) => {
      relationships.forEach(({ data }: GetRelationshipsResponse) => {
        const included: GetDataResponse<any>[] = [];

        data.forEach((datum: GetRelationshipsDataResponse) => {
          if (datum.id === include.id && datum.type === include.type) {
            included.push(include);
          }
        });

        Array.isArray(state) ?
          state.push({ ...attributes, included }) :
          Object.assign(state, { ...attributes, included });
      });
    });

    return;
  }

  Array.isArray(state) ?
    state.push(attributes) :
    Object.assign(state, attributes);
};

export const refreshList = (
  state: any,
  purged?: DeleteResponse['data']['attributes']['purged'] | null,
  id?: number | null,
  attributes?: any
) => {
  if (!purged && id && attributes) {
    Object.assign(state[
      state.findIndex((model: any) => model.id === id)
    ], attributes);

    return;
  }

  if (purged && !id && !attributes) {
    purged.forEach(({ id }) => {
      state.splice(state.findIndex((model: any) => model.id === Number(id)), 1);
    });

    return;
  }

  state.push(attributes);
};
